import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Docs, DocsParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询文档
 */
export async function pageDocs(params: DocsParam) {
  const res = await request.get<ApiResult<PageResult<Docs>>>(
    MODULES_API_URL + '/cms/docs/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询文档列表
 */
export async function listDocs(params?: DocsParam) {
  const res = await request.get<ApiResult<Docs[]>>(
    MODULES_API_URL + '/cms/docs',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加文档
 */
export async function addDocs(data: Docs) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/docs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改文档
 */
export async function updateDocs(data: Docs) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/docs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除文档
 */
export async function removeDocs(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/docs/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除文档
 */
export async function removeBatchDocs(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/docs/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户状态
 */
export async function updateDocsStatus(docsId?: number, status?: number) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/docs/status',
    {
      docsId,
      status
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询文档
 */
export async function getDocs(id: number) {
  const res = await request.get<ApiResult<Docs>>(
    MODULES_API_URL + '/cms/docs/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/docs/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
